/* 
 * Copyright (C) 2006 Registro.br. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 1. Redistribution of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY REGISTRO.BR ``AS IS AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIE OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL REGISTRO.BR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
/* $Id: BrOrgUpdate.cpp 536 2006-03-03 15:00:29Z cesar $ */

#include "config.h"

#include "BrOrgUpdate.H"
#include "StrUtil.H"


LIBEPP_NICBR_NS_BEGIN

void BrOrgUpdate::set_xml_template(const string &xml_template)
{
  ContactUpdate::set_xml_template(xml_template);

  map < string, string, less<string> > to_parse;
  
  to_parse["organization"] = get_command()->get_organization();

  map< string, string, less<string> >::const_iterator it;
  map< string, string, less<string> > contact_list;

  if (!get_command()->get_contact_list_add().empty()) {
    to_parse["brorg_add"] = "<brorg:add>";
    contact_list = get_command()->get_contact_list_add();
    for (it = contact_list.begin(); it != contact_list.end(); it++) {
      to_parse["brorg_add"] += "<brorg:contact type='" +
	(*it).first + "'>" + (*it).second + "</brorg:contact>";
    }
    to_parse["brorg_add"] += "</brorg:add>";
  }
  
  if (!get_command()->get_contact_list_rem().empty()) {
    to_parse["brorg_rem"] = "<brorg:rem>";
    contact_list = get_command()->get_contact_list_rem();
    for (it = contact_list.begin(); it != contact_list.end(); it++) {
      to_parse["brorg_rem"] += "<brorg:contact type='" +
	(*it).first + "'>" + (*it).second + "</brorg:contact>";
    }
    to_parse["brorg_rem"] += "</brorg:rem>";
  }
  
  _xml = StrUtil::parse(_xml, to_parse, "$(", ")$");
}

LIBEPP_NICBR_NS_END
